/* all float vriable are changed into double variables */
/* as a consequence all call to 'vector()' and to 'dmatrix()' */
/* are changed into 'dvector()' and 'ddmatrix' resp. */
/* plus, of course, free_vector and free_dmatrix into */
/* free_dvector and free_ddmatrix */


#include <math.h>
#define NRANSI
#include "nrutil.h"

int Interrupt();

void usrfun(double *x,int n,double *fvec,double **fjac);
#define FREERETURN {free_dmatrix(fjac,1,n,1,n);free_dvector(fvec,1,n);\
	free_dvector(p,1,n);free_ivector(indx,1,n);return (k<=ntrial);}

int mnewt(int ntrial, double x[], int n, double tolx, double tolf)
{
  void lubksb(double **a, int n, int *indx, double b[]);
  void ludcmp(double **a, int n, int *indx, double *d);
  int k,i,*indx;
  double errx,errf,d,*fvec,**fjac,*p;
  
  indx=ivector(1,n);
  p=dvector(1,n);
  fvec=dvector(1,n);
  fjac=dmatrix(1,n,1,n);
  for (k=1;k<=ntrial;k++) {
    if (Interrupt()) {
      k=ntrial+1;
      FREERETURN;
    }
    usrfun(x,n,fvec,fjac);
    errf=0.0;
    for (i=1;i<=n;i++) errf += fabs(fvec[i]);
    if (errf <= tolf) FREERETURN
    for (i=1;i<=n;i++) p[i] = -fvec[i];
    ludcmp(fjac,n,indx,&d);
    lubksb(fjac,n,indx,p);
    errx=0.0;
    for (i=1;i<=n;i++) {
      errx += fabs(p[i]);
      x[i] += p[i];
    }
    if (errx <= tolx) FREERETURN
  }
  FREERETURN
}
#undef FREERETURN
#undef NRANSI
/* (C) Copr. 1986-92 Numerical Recipes Software %6<5@)1.#109. */
